/* $Id: NSEvent-WIAppKit.m 6486 2009-01-02 15:45:29Z morris $ */

/*
 *  Copyright (c) 2003-2009 Axel Andersson
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#import <WiredAppKit/NSEvent-WIAppKit.h>

@implementation NSEvent(WIAppKit)

- (unichar)character {
	NSString	*string;
	
	string = [self characters];
	
	return [string length] == 0 ? 0 : [string characterAtIndex:0];
}



- (unichar)characterIgnoringModifiers {
	NSString	*string;
	
	string = [self charactersIgnoringModifiers];
	
	return [string length] == 0 ? 0 : [string characterAtIndex:0];
}



- (BOOL)commandKeyModifier {
	return (([self modifierFlags] & NSCommandKeyMask) != 0);
}



- (BOOL)alternateKeyModifier {
	return (([self modifierFlags] & NSAlternateKeyMask) != 0);
}



- (BOOL)controlKeyModifier {
	return (([self modifierFlags] & NSControlKeyMask) != 0);
}



- (BOOL)shiftKeyModifier {
	return (([self modifierFlags] & NSShiftKeyMask) != 0);
}

@end
