/* $Id: WIP7NotificationCenter.h 6486 2009-01-02 15:45:29Z morris $ */

/*
 *  Copyright (c) 2008-2009 Axel Andersson
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

#import <WiredNetworking/WIP7Message.h>

@interface WIP7NotificationCenter : WIObject {
	NSMutableArray					*_messageNameObservers;
	NSMutableArray					*_transactionObservers;
}

- (void)addObserver:(id)observer selector:(SEL)selector messageName:(NSString *)messageName;
- (void)addObserver:(id)observer selector:(SEL)selector transaction:(WIP7UInt32)transaction;
- (void)removeObserver:(id)observer messageName:(NSString *)messageName;
- (void)removeObserver:(id)observer transaction:(WIP7UInt32)transaction;
- (void)removeObserver:(id)observer;
- (void)postMessageName:(NSString *)messageName message:(WIP7Message *)message;
- (void)postTransaction:(WIP7UInt32)transaction message:(WIP7Message *)message;

@end
